SystemOrganization addCategory: #'GBT-DSL-MFXApp'!

Object subclass: #MFXApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXApp subclass: #AccessManagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXApp subclass: #Admninistration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

!MFXApp class methodsFor: 'examples' stamp: 'cc 12/14/2017 16:28'!
exampleRun
	GbtServer clearStore; initialize. 
	self installUsers.
	self new ensureCompilation.
	(self new 
		ensureCompilation ;
		loginContext) ui 
			title: #Login; 
			open! !

!MFXApp class methodsFor: 'examples' stamp: 'cc 12/14/2017 14:32'!
installUsers
		#(Isabell Uwe Klaus) do: [:u| GbtServer default addUser: u withRole: GbtRole forExecute ].
		#(Isabell Uwe Klaus) do: [:u| GbtServer default addUser: u withRole: GbtRole forWrite ].
		#(Isabell Uwe Klaus) do: [:u| GbtServer default addUser: u withRole: GbtRole forRead ]! !

!MFXApp methodsFor: 'functions' stamp: 'cc 12/14/2017 14:28'!
behaviors
	^''
! !

!MFXApp methodsFor: 'contexts' stamp: 'cc 12/14/2017 16:30'!
contexts
	^'
	plain MFXLogin {
	displayAs	: MFX
	icon	: efa
	uiSpec	: GbtLoginUI
	subcontexts	: MFX 
	legalText	: Gbt © 2018
	}
plain MFX {
	displayAs	: MFX
	icon	: efa
	uiSpec	: GbtMainUI
	windowSize	: 1200@800
	legalText	: Gbt © 2018
	}
'! !

!MFXApp methodsFor: 'functions' stamp: 'cc 12/14/2017 14:28'!
directives
	^''
! !

!MFXApp methodsFor: 'compile' stamp: 'cc 12/14/2017 14:30'!
ensureCompilation
	"sort of incremental ..."
	GbtCompiler new parse: self things onError: [ :msg :pos | self error: msg, ' at: ', pos printString ]. 
	GbtCompiler new parse: self directives onError: [ :msg :pos | self error: msg, ' at: ', pos printString ].
	GbtCompiler new parse: self contexts onError: [ :msg :pos | self error: msg, ' at: ', pos printString].
	GbtCompiler new parse: self behaviors  onError: [ :msg :pos | self error: msg, ' at: ', pos printString]. ! !

!MFXApp methodsFor: 'testData' stamp: 'cc 12/12/2017 20:51'!
installUsers
	#(Isabell Uwe Klaus) do: [:u| GbtServer default addUser: u withRole: 
			(GbtRole forExecute 
				addFilter: '#firstName = ''',u asString, '''' for: #MyAccounts;
				addFilter: '#senderName = ''',u asString, '''' for: #Transfers) ].
	#(Klaus) do: [:u| GbtServer default addUser: u withRole: (GbtRole forWrite )].
	#(Isabell) do: [:u| GbtServer default addUser: u withRole: (GbtRole forRead )]! !

!MFXApp methodsFor: 'contexts' stamp: 'cc 12/14/2017 16:29'!
loginContext 
	^GbtActiveContext definedAs: 'MFXLogin' ! !

!MFXApp methodsFor: 'testData' stamp: 'cc 12/12/2017 20:43'!
nextBizID
	^GbtServer default nextIdOfContextNoPolicy: #MyAccounts! !

!MFXApp methodsFor: 'testData' stamp: 'cc 12/12/2017 20:42'!
storeTestData
	"creates the noPolicy for the test data"
	GbtServer default contextNoPolicyOf: #MyAccounts prefix: #Acc	.
	self account01 storeSubtree.
'	self account02 storeSubtree.
	self account03 storeSubtree. 
	self account04 storeSubtree.
	self account05 storeSubtree'! !

!MFXApp methodsFor: 'things' stamp: 'cc 12/14/2017 14:28'!
things
	^''! !

MFXApp subclass: #MFXBilling
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXApp subclass: #MFXMasterData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXMasterData subclass: #MFXApplications
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

!MFXApplications methodsFor: 'things' stamp: 'cc 12/14/2017 14:41'!
things
^'	thing Application  
		summary : system template
		{
		*val ApplicationName 		:  
		val ApplicationShort  		:  
		val ICTO     		:   					
		val OwnerDepartment     		:   
		val 	OLAContractNo :
		bool XCharge  : 
		}
'! !

MFXMasterData subclass: #MFXChangeLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXMasterData subclass: #MFXCustomers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

!MFXMasterData class methodsFor: 'examples' stamp: 'cc 12/14/2017 16:53'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		masterDataContext) ui 
			title: #MasterData; 
			open! !

!MFXMasterData methodsFor: 'things' stamp: 'cc 12/14/2017 16:34'!
behaviors
^''! !

!MFXMasterData methodsFor: 'contexts' stamp: 'cc 12/14/2017 16:53'!
contexts
	^ '	plain MasterDataContext {
		subcontexts 	: 	ApplicationsContext
		uiSpec 		: 	GbtItemWithTabsUI
		icon 			: 	settings
		displayAs 	: 	MasterData
		legalText 	: 	Gbt © 2018
		}
		
	plain ApplicationsContext on Applications {  
	 	displayAs 	: 	Applications
		uiSpec 		: 	GbtItemUI
		icon 			: 	settings
		}
		
	plain ServiceCatalogsContext on ServiceCatalogs {  
	 	displayAs 	: 	ServiceCatalogs
		uiSpec 		: 	GbtItemUI
		icon 			: 	settings
		}
	'
! !

!MFXMasterData methodsFor: 'things' stamp: 'cc 12/14/2017 16:34'!
directives
^''! !

!MFXMasterData methodsFor: 'contexts' stamp: 'cc 12/14/2017 16:54'!
masterDataContext
	^GbtActiveContext definedAs: 'MasterDataContext' ! !

!MFXMasterData methodsFor: 'things' stamp: 'cc 12/14/2017 16:51'!
things
^'	thing Applications
	{ no XChargedApplications : 7
	list Applications : Application
	 }
	thing Application  
		summary : system template
		{
		*val ApplicationName 		:  
		val ApplicationShort  		:  
		val ICTO     		:   					
		val OwnerDepartment     		:   
		val 	OLAContractNo :
		bool XCharge  : 
		}
'! !

MFXMasterData subclass: #MFXOrgData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXMasterData subclass: #MFXServiceCatalog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXMasterData subclass: #MFXServiceUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXApp subclass: #MFXOperationalData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXApp subclass: #MFXOperationsControl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXApp subclass: #MFXPriceCalculation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXApp subclass: #MFXServiceManagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!

MFXApp subclass: #PriceCalculation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-MFXApp'!
